import { ReactElement } from 'react';
import { Channel } from '@storybook/channels';
import { API } from '@storybook/api';
import { types, Types, isSupportedType } from './types';
export interface RenderOptions {
    active: boolean;
    key: string;
}
export interface RouteOptions {
    storyId: string;
}
export interface MatchOptions {
    viewMode: string;
}
export interface Addon {
    title: string;
    type?: Types;
    id?: string;
    route?: (routeOptions: RouteOptions) => string;
    match?: (matchOptions: MatchOptions) => boolean;
    render: (renderOptions: RenderOptions) => ReactElement<any>;
}
export declare type Loader = (api: API) => void;
export { types, Types, isSupportedType };
export interface Collection {
    [key: string]: Addon;
}
export declare class AddonStore {
    private loaders;
    private elements;
    private channel;
    getChannel: () => Channel;
    hasChannel: () => boolean;
    setChannel: (channel: Channel) => void;
    getElements: (type: string) => Collection;
    addPanel: (name: string, options: Addon) => void;
    add: (name: string, addon: Addon) => void;
    register: (name: string, registerCallback: (api: API) => void) => void;
    loadAddons: (api: any) => void;
}
export declare const addons: AddonStore;
