import { Module } from '../index';
import { PanelPositions } from './layout';
interface Additions {
    isFullscreen?: boolean;
    showPanel?: boolean;
    panelPosition?: PanelPositions;
    showNav?: boolean;
    selectedPanel?: string;
}
export interface QueryParams {
    [key: string]: string | null;
}
export interface SubAPI {
    getQueryParam: (key: string) => string | undefined;
    getUrlState: () => {
        queryParams: QueryParams;
        path: string;
        viewMode?: string;
        storyId?: string;
        url: string;
    };
    setQueryParams: (input: QueryParams) => void;
}
export default function ({ store, navigate, location, path: initialPath, ...rest }: Module): {
    api: SubAPI;
    state: {
        layout: Additions;
        selectedPanel: any;
        location: import("@reach/router").WindowLocation;
        path: string;
        customQueryParams: {
            [key: string]: any;
        };
    };
};
export {};
